import React, { useState } from "react";
import { Button, Input } from "antd";
import useAuth from "../../useAuth";
import { useLocation, useNavigate } from "react-router";

export const LogIn = () => {
    const { login, loading, error } = useAuth();
    const [email, setEmail] = useState("");
    const [password, setPassword] = useState("");
    const navigate = useNavigate();

    const location = useLocation();
    const { state } = location;

    return (
        <div className="Box Small">
            <div className="Section">
                <div className="Section">
                    <h2>Login</h2>
                    <Input
                        placeholder="User"
                        name="User"
                        onChange={(ev) => setEmail(ev.target.value)}
                    />
                    <Input.Password
                        placeholder="Password"
                        name="Password"
                        onChange={(ev) => setPassword(ev.target.value)}
                    />
                    <Button
                        style={{ width: "100%" }}
                        onClick={async () =>
                            login({ email, password }, state)
                        }
                        name="Login"
                        loading={loading}
                    >
                        Log in
                    </Button>
                    <Button
                        style={{ width: "100%", marginTop: '20px' }}
                        onClick={() =>
                            navigate("/signup")
                        }
                        name="Signup"
                    >
                        Sign up
                    </Button>
                    {error ? (
                        <div className="Disconnected">{error}</div>
                    ) : (
                        <></>
                    )}
                </div>
            </div>
        </div>
    );
};
