import json

from fastapi.testclient import TestClient

from src.api.main import app
from src.api.models.subscription import Subscription

client = TestClient(app)


mocked_subscription = {"user_id": 1, "flight_id": 1}


def test_post_subscription(test_database, get_subscription):
    test_database.query(Subscription).delete()

    api_call_retrieved_subscription = client.post(
        "/subscriptions", data=json.dumps(mocked_subscription)
    )
    api_call_retrieved_subscription_data = api_call_retrieved_subscription.json()
    db_retrieved_subscription = get_subscription(
        api_call_retrieved_subscription_data["user_id"],
        api_call_retrieved_subscription_data["flight_id"],
    )

    assert db_retrieved_subscription.user_id == mocked_subscription["user_id"]
